package cn.wisenergy.service.impl;

import cn.wisenergy.common.utils.exception.BASE_RESP_CODE_ENUM;
import cn.wisenergy.common.utils.exception.BaseCustomException;
import cn.wisenergy.mapper.WorkOrderChangeMapper;
import cn.wisenergy.model.dto.WorkOrderChangeLogDto;
import cn.wisenergy.model.enums.LevelEnum;
import cn.wisenergy.model.vo.OrderChangeLogVo;
import cn.wisenergy.service.WorkOrderChangeService;
import cn.wisenergy.service.utils.UserRoleLevelUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Authotr:陈奇
 * @QQ1799796883
 */
@Service
@Slf4j
public class WorkOrderChangeImpl implements WorkOrderChangeService {

    @Autowired
    private WorkOrderChangeMapper workOrderChangeMapper;

    @Override
    public PageInfo getOrderChangeLogPage(OrderChangeLogVo vo) {
        log.info("WorkOrderChangeImpl[]getOrderChangeLogPage[]input.param.OrderChangeLogVo:{}", vo);
        vo.setPage(null == vo.getPage() ? 1 : vo.getPage());
        vo.setPageSize(null == vo.getPageSize() ? 10 : vo.getPageSize());
        if (null == vo || null == vo.getUserId()) {
            throw new BaseCustomException(BASE_RESP_CODE_ENUM.INPUT_PARAM_IS_NULL);
        }
        List<Integer> ranks = UserRoleLevelUtils.getRankByUserAndLevelName(vo.getUserId(), LevelEnum.WORKORDER_CHANGERECORD.getLevelName());
        // 分权限查询 TODO


        PageHelper.startPage(vo.getPage(), vo.getPageSize());
        List<WorkOrderChangeLogDto> workOrderChangeLogDto = workOrderChangeMapper.getWorkOrderChangeLogDto(vo);
        PageInfo<WorkOrderChangeLogDto> pageInfo = new PageInfo<>(workOrderChangeLogDto);
        pageInfo.setList(workOrderChangeLogDto);
        return pageInfo;
    }
}
